package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

func AgentOrderListRelateByOidAndPvd(Db *xorm.Engine, oid, pvd string) ([]*model.RegionalAgentCalcSystemRelate, error) {
	var o []*model.RegionalAgentCalcSystemRelate
	err := Db.Where("belong_ord_id = ? AND  pvd = ?", oid, pvd).Find(&o)
	if err != nil {
		return nil, logx.Error(err)
	}
	return o, nil
}
func AgentOrderListRelateByOidAndPvdWithSession(session *xorm.Session, oid, pvd string) ([]*model.RegionalAgentCalcSystemRelate, error) {
	var o []*model.RegionalAgentCalcSystemRelate
	err := session.Where("belong_ord_id = ? AND  pvd = ?", oid, pvd).Find(&o)
	if err != nil {
		return nil, logx.Error(err)
	}
	return o, nil
}
func AgentOrderListRelateUpdate(Db *xorm.Engine, oid, pvd string, status int) error {
	var o model.RegionalAgentCalcSystemRelate
	o.Status = status
	_, err := Db.Where("belong_ord_id = ? AND  pvd = ?", oid, pvd).Cols("status").Update(&o)
	if err != nil {
		return err
	}
	return nil
}
func AgentOrderListRelateUpdateWithSession(session *xorm.Session, oid, pvd string, status int) error {
	var o model.RegionalAgentCalcSystemRelate
	o.Status = status
	_, err := Db.Where("belong_ord_id = ? AND  pvd = ?", oid, pvd).Cols("status").Update(&o)
	if err != nil {
		return err
	}
	return nil
}
