package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

func BrightOilOrdByOid(Db *xorm.Engine, oid string) (*model.BrightOilOrd, error) {
	var o model.BrightOilOrd
	if has, err := Db.Where("oid = ?", oid).Get(&o); err != nil || !has {
		return nil, logx.Error(err)
	}
	return &o, nil
}
func BrightOilOrd(Db *xorm.Engine, uid int) (*[]model.BrightOilOrd, error) {
	var o []model.BrightOilOrd
	if err := Db.Where("uid = ? ", uid).Desc("create_at").Find(&o); err != nil {
		return nil, logx.Error(err)
	}
	return &o, nil
}
func BrightOilOrdByUidWithPvdOid(Db *xorm.Engine, uid int, pvdOid string) (*model.BrightOilOrd, error) {
	var o model.BrightOilOrd
	if has, err := Db.Where("uid = ? and pvd_oid=?", uid, pvdOid).Get(&o); err != nil || !has {
		return nil, logx.Error(err)
	}
	return &o, nil
}

func BrightOilInsert(Db *xorm.Engine, data *model.BrightOilOrd) error {
	if _, err := Db.InsertOne(data); err != nil {
		return logx.Warn(err)
	}
	return nil
}
func BrightOilUpdate(Db *xorm.Engine, oid string, state int) error {
	if _, err := Db.Where("`oid` = ?", oid).Cols("state").Update(&model.BrightOilOrd{State: state}); err != nil {
		return logx.Warn(err)
	}
	return nil
}
