package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"fmt"
	"time"
	"xorm.io/xorm"
)

//匹配渠道id是否存在
func DealOrderUserByRelationID(Db *xorm.Engine, RelationID int64, types string) (bool, error) {
	has, err := Db.Where("type= ? and relation_id = ? and end_time>?", types, RelationID, time.Now().Unix()).Exist(&model.DealOrderUser{})

	if err != nil {
		return false, err
	}
	return has, nil
}

//查出用户id的数据 未过期
func DealOrderUserByUid(Db *xorm.Engine, types string, uid interface{}) (*[]model.DealOrderUser, error) {
	var m []model.DealOrderUser
	if err := Db.Where("type=? and uid = ? and end_time>?", types, uid, time.Now().Unix()).Find(&m); err != nil {
		return nil, logx.Warn(err)
	}
	return &m, nil
}

//查出用户id的所有数据
func DealOrderUserByOne(Db *xorm.Engine, types string, uid interface{}) (*[]model.DealOrderUser, error) {
	var m []model.DealOrderUser
	if err := Db.Where("type=? and uid = ? ", types, uid).Find(&m); err != nil {
		return nil, logx.Warn(err)
	}
	return &m, nil
}
func DealOrderUserByTbPids(eg *xorm.Engine, pids []int64, types string) (*[]model.DealOrderUser, error) {
	var m []model.DealOrderUser
	col := "relation_id"
	if err := eg.Where("end_time>? and type = ?", time.Now().Unix(), types).In(col, pids).Find(&m); err != nil {
		return nil, logx.Warn(err)
	}
	if len(m) == 0 {
		return nil, nil
	}
	return &m, nil
}

//查询一页多少个数据
func DealOrderUserByTypeEndtime(Db *xorm.Engine, types string, limits int) ([]*model.DealOrderUser, error) {
	var o []*model.DealOrderUser
	err := Db.Where("type = ? and end_time>?", types, time.Now().Unix()).Limit(limits, 0).Find(&o)
	fmt.Println(time.Now().Unix())
	fmt.Println(types)
	fmt.Println(o)
	if err != nil {
		return nil, logx.Error(err)
	}
	return o, nil
}

//删除过期信息
func DealOrderUserByDel(Db *xorm.Engine, types string) (int64, error) {
	var m model.DealOrderUser
	affect, err := Db.Where("type =? and end_time <?", types, time.Now().Unix()).Delete(&m)
	if err != nil {
		return 0, logx.Warn(err)
	}
	return affect, nil
}
