package db

import (
	"applet/app/db/model"
	"applet/app/md"
	"applet/app/utils/logx"
	"time"
	"xorm.io/xorm"
)

func MoreNewcomersFreeCfg(Db *xorm.Engine) *model.SysCfg {
	var cfg model.SysCfg
	if _, err := Db.Where("`key` = 'more_newcomers_free_cfg'").Get(&cfg); err != nil {
		_ = logx.Warn(err)
	}
	return &cfg
}

func GetMorePriceTypeById(Db *xorm.Engine, id int) *model.MoreNewcomersFreePriceType {
	var price model.MoreNewcomersFreePriceType
	if _, err := Db.Where("`is_del` = 0 and `is_show` = 1 and id=?", id).Get(&price); err != nil {
		_ = logx.Warn(err)
	}
	return &price
}

func MorePriceTypeList(Db *xorm.Engine) *[]model.MoreNewcomersFreePriceType {
	var priceList []model.MoreNewcomersFreePriceType
	if err := Db.Where("`is_del` = 0 and `is_show` = 1 ").OrderBy("sort desc,id desc").Find(&priceList); err != nil {
		_ = logx.Warn(err)
	}
	return &priceList
}
func MoreGetAllPriceTypeList(Db *xorm.Engine) ([]model.MoreNewcomersFreePriceType, error) {
	var priceType []model.MoreNewcomersFreePriceType
	if err := Db.Find(&priceType); err != nil {
		return nil, logx.Warn(err)
	}
	return priceType, nil
}

func MoreProductList(Db *xorm.Engine, args *md.NewProductArgs) []*model.MoreNewcomersFreeProduct {
	query := "`is_del` = 0 and is_show = 1 and stock>0"
	if args.PriceType != "" {
		query += " and price_type = " + args.PriceType
	}
	nowStr := time.Now().Format("2006-01-02 15:04:05")
	query += " and start_time<'" + nowStr + "'"
	query += " and end_time>'" + nowStr + "'"
	if args.ProductId != "" {
		query += " and id = " + args.ProductId
	}
	if args.Title != "" {
		query += " and title like '%" + args.Title + "%'"
	}
	//if args.Page == 0 {
	//	args.Page = 1
	//}
	//size := 10
	//start := size * (args.Page - 1)
	var productList []*model.MoreNewcomersFreeProduct
	sess := Db.Where(query).OrderBy("sort desc,id desc")
	if args.P > 0 {
		sess = sess.Limit(10, (args.P-1)*10)
	}
	if err := sess.Find(&productList); err != nil {
		_ = logx.Warn(err)
	}
	return productList
}

func GetMoreProductListByPriceType(Db *xorm.Engine, priceTypeId string, page int) []*model.MoreNewcomersFreeProduct {
	query := "`is_del` = 0 and is_show = 1  and stock>0"
	if priceTypeId != "" {
		query += " and price_type = " + priceTypeId
	}
	nowStr := time.Now().Format("2006-01-02 15:04:05")
	query += " and start_time<'" + nowStr + "'"
	query += " and end_time>'" + nowStr + "'"
	size := 10
	start := 0
	if page > 0 {
		start = size * (page - 1)
	}
	var productList []*model.MoreNewcomersFreeProduct
	if err := Db.Where(query).Limit(size, start).Find(&productList); err != nil {
		_ = logx.Warn(err)
	}
	//fmt.Println(productList)
	return productList
}

func GetMoreOneProductListByPriceType(Db *xorm.Engine, priceTypeId string) *model.MoreNewcomersFreeProduct {
	query := "`is_del` = 0 and is_show = 1 and stock>0"
	if priceTypeId != "" {
		query += " and price_type = " + priceTypeId
	}
	nowStr := time.Now().Format("2006-01-02 15:04:05")
	query += " and start_time<'" + nowStr + "'"
	query += " and end_time>'" + nowStr + "'"

	var product model.MoreNewcomersFreeProduct
	if has, err := Db.Where(query).OrderBy("sort desc,id desc").Get(&product); !has || err != nil {
		_ = logx.Warn(err)
	}
	//fmt.Println(product)
	return &product
}

func MoreOneProduct(Db *xorm.Engine, productId string) *model.MoreNewcomersFreeProduct {
	query := "`is_del` = 0 and is_show = 1"
	query += " and id = " + productId
	var product model.MoreNewcomersFreeProduct
	if _, err := Db.Where(query).Get(&product); err != nil {
		_ = logx.Warn(err)
	}
	return &product
}

func GetMoreAllPriceType(Db *xorm.Engine) (map[int]string, error) {
	var priceType []model.MoreNewcomersFreePriceType
	if err := Db.Find(&priceType); err != nil {
		return nil, logx.Warn(err)
	}
	r := make(map[int]string, len(priceType))
	for _, v := range priceType {
		r[v.Id] = v.PriceName
	}
	return r, nil
}
