package db

import (
	"applet/app/db/model"
	"applet/app/md"
	"applet/app/utils"
	"errors"
	"github.com/syyongx/php2go"
	"strings"

	"xorm.io/xorm"
)

// FreeProductByID is 获取新人免单对应的商品id
func FreeProductByID(Db *xorm.Engine, gid, skuId, provider string) (*model.NewcomersFreeProduct, error) {
	m := new(model.NewcomersFreeProduct)
	var has bool
	var err error
	if utils.InArr(provider, []string{md.PVD_TB, md.PVD_TM}) && php2go.IsNumeric(gid) == false {
		gidArr := strings.Split(gid, "-")
		if len(gidArr) == 2 {
			gid = gidArr[1]
		}
		has, err = Db.Where("good_id LIKE ?", "%-"+gid).Get(m)
	} else {
		sess := Db.Where("good_id=?", gid)
		if skuId != "" {
			sess.Or("good_id=?", skuId)
		}
		has, err = sess.Get(m)
	}

	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("Not Found")
	}

	return m, nil
}
func MoreFreeProductByID(Db *xorm.Engine, gid, skuId, provider string) (*model.MoreNewcomersFreeProduct, error) {
	m := new(model.MoreNewcomersFreeProduct)
	var has bool
	var err error
	if utils.InArr(provider, []string{md.PVD_TB, md.PVD_TM}) && php2go.IsNumeric(gid) == false {
		gidArr := strings.Split(gid, "-")
		if len(gidArr) == 2 {
			gid = gidArr[1]
		}
		has, err = Db.Where("good_id LIKE ?", "%-"+gid).Get(m)
	} else {
		sess := Db.Where("good_id=?", gid)
		if skuId != "" {
			sess.Or("good_id=?", skuId)
		}
		has, err = sess.Get(m)
	}

	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("Not Found")
	}

	return m, nil
}
