package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

// 根据订单id查出相关的数据
func GetVirtualCoinRelateListWithOrdId(engine *xorm.Engine, ordId int64) ([]*model.VirtualCoinRelate, error) {
	var list []*model.VirtualCoinRelate
	err := engine.Table("virtual_coin_relate").Where("oid = ?", ordId).Find(&list)
	if err != nil {
		return nil, err
	}
	return list, nil
}
func VirtualCoinOrderRelateListByOid(Db *xorm.Engine, oid int64, pvd string) ([]*model.VirtualCoinRelate, error) {
	var ol []*model.VirtualCoinRelate
	err := Db.Where("oid=? and pvd=?", oid, pvd).Find(&ol)
	if err != nil {
		return nil, logx.Error(err)
	}
	return ol, nil
}
func GetOrdCoinRelateById(Db *xorm.Engine, id string, uid int) *[]model.VirtualCoinRelate {
	var items []model.VirtualCoinRelate
	err := Db.Where("oid = ? and uid=?", id, uid).Find(&items)
	if err != nil {
		return nil
	}
	return &items
}
