package model

type BrightOilOrd struct {
	Id             int     `json:"id" xorm:"not null pk autoincr INT(11)"`
	Oid            int64   `json:"oid" xorm:"default 0 comment('订单号') BIGINT(20)"`
	PvdOid         string  `json:"pvd_oid" xorm:"default '' comment('渠道订单号') VARCHAR(100)"`
	OrderAmount    float64 `json:"order_amount" xorm:"default 0.00 comment('原始价格') DOUBLE(11,2)"`
	PayAmount      float64 `json:"pay_amount" xorm:"default 0.00 comment('付款价格') DOUBLE(11,2)"`
	DiscountAmount float64 `json:"discount_amount" xorm:"default 0.00 comment('优惠金额') DOUBLE(11,2)"`
	Commission     float64 `json:"commission" xorm:"default 0.00 comment('总佣金') DOUBLE(11,2)"`
	Uid            int     `json:"uid" xorm:"default 0 INT(11)"`
	MemberId       string  `json:"member_id" xorm:"default '' comment('渠道用户id') VARCHAR(20)"`
	State          int     `json:"state" xorm:"default 0 comment('支付状态：0-未支付，1-已支付，2-已取消)') INT(11)"`
	CreateTime     int     `json:"create_time" xorm:"default 0 comment('')') INT(11)"`
	UpdateTime     int     `json:"update_time" xorm:"default 0 comment('')') INT(11)"`
	NextUpdateTime int     `json:"next_update_time" xorm:"default 0 comment('')') INT(11)"`
	Data           string  `json:"data" xorm:"comment('拓展') LONGTEXT"`
	StationName    string  `json:"station_name" xorm:"default '' comment('油站名称') VARCHAR(255)"`
}
