package zhimeng

import (
	"applet/app/e"
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"encoding/json"
	"fmt"
)

//权益卡退款订单
func CardOrderTrack(appKey, appSecret, zuid string) (*[]md.CardOrderInfo, error) {
	params := map[string]interface{}{
		"appkey":     appKey,
		"secret_key": appSecret,
		"zuid":       zuid,
	}
	resp, err := Send("hccard_list", "return_order", params)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Msg     string             `json:"msg"`
		Success int                `json:"success"`
		Data    []md.CardOrderInfo `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("[resp]: " + string(resp) + ", [err]:" + err.Error())
	}
	if len(tmp.Data) == 0 {
		return nil, e.NewErrCode(e.ERR_NO_DATA)
	}
	return &tmp.Data, nil
}

func FindCardOrderTrack(appKey, appSecret, oid string) (*[]md.CardOrderInfo, error) {
	params := map[string]interface{}{
		"appkey":     appKey,
		"secret_key": appSecret,
		"oid":        oid,
	}
	resp, err := Send("hccard_list", "find_order", params)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Msg     string             `json:"msg"`
		Success int                `json:"success"`
		Data    []md.CardOrderInfo `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		fmt.Println("========find_order=======")
		fmt.Println(err)
		fmt.Println("===============")
		return nil, logx.Warn("[resp]: " + string(resp) + ", [err]:" + err.Error())
	}
	if len(tmp.Data) == 0 {
		return nil, nil
	}
	return &tmp.Data, nil
}
func FindCardUpdateOrderTrack(appKey, appSecret string, pageNo int, sTime, eTime int64) ([]md.CardOrderInfo, error) {
	params := map[string]interface{}{
		"appkey":     appKey,
		"secret_key": appSecret,
		"p":          utils.IntToStr(pageNo),
		"start_time": utils.Int64ToStr(sTime),
		"end_time":   utils.Int64ToStr(eTime),
	}
	resp, err := Send("hccard_list", "update_order", params)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Msg     string             `json:"msg"`
		Success int                `json:"success"`
		Data    []md.CardOrderInfo `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("[resp]: " + string(resp) + ", [err]:" + err.Error())
	}
	if len(tmp.Data) == 0 {
		return nil, nil
	}
	return tmp.Data, nil
}
