package zhimeng

import (
	"applet/app/e"
	"applet/app/md"
	"applet/app/utils/logx"
	"encoding/json"
	"strconv"
)

func MeituanConvertUrl(appkey, appsecret, source string, isShare int, user *md.User, actId string, is_new int) (*md.OfficialRecommendUrl, error) {
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"act_id":     actId,
		"source":     source,
		"phone":      user.Info.Phone,
		"zuid":       strconv.Itoa(user.Info.Uid),
		"is_share":   strconv.Itoa(isShare),
		"is_zyos":    "1",
	}
	var resp []byte
	var err error
	if is_new == 1 {
		resp, err = Send("meituan", "zyos_act", args)
	} else {
		resp, err = Send("meituan", "act", args)
	}
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			TakeoutUrl        string `json:"act_url"`          //到店
			ShopUrl           string `json:"wm_url"`           //外卖
			HotelUrl          string `json:"act_hotelurl"`     //酒店
			SupermarketUrl    string `json:"act_storeurl"`     //商超
			MoreUrl           string `json:"more_url"`         //商超
			TakeoutQrcode     string `json:"act_qrcode"`       //到店
			ShopQrcode        string `json:"wm_qrcode"`        //外卖
			HotelQrcode       string `json:"act_hotel_qrcode"` //酒店
			SupermarketQrcode string `json:"act_store_qrcode"` //商超
			MoreQrcode        string `json:"more_qrcode"`      //商超
			TakeoutPath       string `json:"act_path"`         //到店
			ShopPath          string `json:"wm_path"`          //外卖
			HotelPath         string `json:"act_hotel_path"`   //酒店
			SupermarketPath   string `json:"act_store_path"`   //商超
			MorePath          string `json:"more_path"`        //商超
			AppId             string `json:"app_id"`           //
		} `json:"data"`
	}

	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}

	var url string
	var WxQrcodeUrl string
	var WxMiniprogramPath string
	switch source {
	case "meituan_takeout":
		url = tmp.Data.TakeoutUrl
		WxQrcodeUrl = tmp.Data.TakeoutQrcode
		WxMiniprogramPath = tmp.Data.TakeoutPath
	case "meituan_shop":
		url = tmp.Data.ShopUrl
		WxQrcodeUrl = tmp.Data.ShopQrcode
		WxMiniprogramPath = tmp.Data.ShopPath

	case "meituan_hotel":
		url = tmp.Data.HotelUrl
		WxQrcodeUrl = tmp.Data.HotelQrcode
		WxMiniprogramPath = tmp.Data.HotelPath

	case "meituan_supermarket":
		url = tmp.Data.SupermarketUrl
		WxQrcodeUrl = tmp.Data.SupermarketQrcode
		WxMiniprogramPath = tmp.Data.SupermarketPath

	case "meituan":
		url = tmp.Data.MoreUrl
		WxQrcodeUrl = tmp.Data.MoreUrl
		WxMiniprogramPath = tmp.Data.MorePath

	default:
		return nil, e.NewErrCode(e.ERR_INVALID_ARGS)
	}
	return &md.OfficialRecommendUrl{
		Url:               url,
		WxQrcodeUrl:       WxQrcodeUrl,
		Appid:             tmp.Data.AppId,
		WxMiniprogramPath: WxMiniprogramPath,
	}, nil
}
