package zhimeng

import (
	"applet/app/e"
	"applet/app/md"
	"applet/app/utils/logx"
	"encoding/json"
	"strconv"
)

func MeituanMiniprogramConvertUrl(appkey, appsecret, source string, isShare int, user *md.User, actId string) (*md.OfficialRecommendUrl, error) {
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"phone":      user.Info.Phone,
		"act_id":     actId,
		"zuid":       strconv.Itoa(user.Info.Uid),
		"is_share":   strconv.Itoa(isShare),
		"is_zyos":    "1",
	}
	resp, err := Send("meituan", "mini_program_urls", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Url      string `json:"takeaway_url"` //外卖
			DDUrl    string `json:"dd_url"`       //到店
			StoreUrl string `json:"store_url"`    //商超
			HotelUrl string `json:"hotel_url"`    //酒店
			MoreUrl  string `json:"more_url"`     //以后新增的活动
			Appid    string `json:"appid"`        //
		} `json:"data"`
	}

	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}

	var url string
	switch source {
	case "meituan_takeout":
		url = tmp.Data.Url
	case "meituan_shop":
		url = tmp.Data.DDUrl
	case "meituan_hotel":
		url = tmp.Data.HotelUrl
	case "meituan_supermarket":
		url = tmp.Data.StoreUrl
	case "meituan":
		url = tmp.Data.MoreUrl
	default:
		return nil, e.NewErrCode(e.ERR_INVALID_ARGS)
	}
	return &md.OfficialRecommendUrl{
		Url:               url,
		WxMiniprogramPath: url,
		Appid:             tmp.Data.Appid,
	}, nil
}
