package zhimeng

import (
	"applet/app/md"
	"applet/app/utils/logx"
	"encoding/json"
	"strconv"
)

func OilConvertUrl(appkey, appsecret string, user *md.User) (*md.OfficialRecommendUrl, error) {
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"phone":      user.Info.Phone,
		"zuid":       strconv.Itoa(user.Info.Uid),
		"is_zyos":    "1",
	}
	resp, err := Send("bright_oil_online", "url", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Url string `json:"url"` //
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.OfficialRecommendUrl{
		Url: tmp.Data.Url,
	}, nil
}
