package zhimeng

import (
	"applet/app/db/model"
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"encoding/json"
	"fmt"
	"strconv"
	"strings"
)

func OilStationConvertUrl(appkey, appsecret string, lat float64, lng float64, user *md.User) (*md.OfficialRecommendUrl, error) {

	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"phone":      user.Info.Phone,
		"nickname":   strings.ReplaceAll(user.Info.Nickname, " ", ""),
		"zuid":       strconv.Itoa(user.Info.Uid),
		"entrance":   "gasoline/home",
		"avatar":     user.Profile.AvatarUrl,
		"is_zyos":    "1",
	}
	if lat > 0 && lng > 0 {
		//args["entrance"] = fmt.Sprintf("gasoline/home?type=%s&lat=%f&lng=%f", "normal", lat, lng)
		args["entrance"] = fmt.Sprintf("gasoline/home?type=%s&lat=%f&lng=%f", "", lat, lng)
	}
	resp, err := Send("shengxintech", "index", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Url string `json:"redirect_url"` //
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn(string(resp))
	}
	return &md.OfficialRecommendUrl{
		Url: tmp.Data.Url,
	}, nil
}
func GroupOilStationConvertUrl(appkey, appsecret string, user *md.User) (*md.OfficialRecommendUrl, error) {
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"phone":      user.Info.Phone,
		"is_zyos":    "1",
	}
	resp, err := Send("oil_station", "czb_url", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Url string `json:"url"` //
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.OfficialRecommendUrl{
		Url: tmp.Data.Url,
	}, nil
}
func GroupOilStationRequest(appkey, appsecret string, lists *model.DealOrderUser) (int, error) {
	args := map[string]interface{}{
		"appkey":     appkey,
		"secret_key": appsecret,
		"phone":      lists.Data,
		"uid":        utils.IntToStr(lists.Uid),
		"begin_time": utils.IntToStr(lists.Time),
		"is_zyos":    "1",
	}
	resp, err := Send("oil_station", "czb_order", args)
	if err != nil {
		return 0, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			NextTime string `json:"next_time"` //
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return 0, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}

	return utils.StrToInt(tmp.Data.NextTime), nil
}
