package zhimeng

import (
	"encoding/json"

	"applet/app/utils/logx"
)

// 从智盟获取淘宝最新的session id
func TaobaoSid() string {
	args := map[string]interface{}{
		// "appkey":     appkey,
		// "secret_key": appsecret,
	}
	resp, err := Send("tb", "get_session", args)
	if err != nil {
		logx.Warn("resp: + " + string(resp) + " + err:" + err.Error())
		return ""
	}
	var tmp struct {
		Data struct {
			ID               string `json:"id"`
			TbSession        string `json:"tb_session"`
			TbSessionSetTime string `json:"tb_session_set_time"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		logx.Warn("resp: + " + string(resp) + " + err:" + err.Error())
		return ""
	}
	if tmp.Data.TbSession == "" {
		logx.Warn("resp: + " + string(resp))
		return ""
	}
	return tmp.Data.TbSession
}
