package zhimeng

import (
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/logx"
	"encoding/json"
	"strconv"
)

func ToDidiUrl(appkey, appsecret string, user *md.User, types string, activityId string, getCode, isShare int) (*md.OfficialRecommendUrl, error) {
	args := map[string]interface{}{
		"appkey":      appkey,
		"secret_key":  appsecret,
		"is_share":    utils.IntToStr(isShare),
		"zuid":        strconv.Itoa(user.Info.Uid),
		"type":        types,      //h5 mini
		"activity_id": activityId, //滴滴货运CPS推广3524 滴滴加油CPS推广3484 滴滴打车CPS推广3026
		"get_code":    utils.IntToStr(getCode),
	}
	resp, err := Send("didi", "getUrl", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			Link      string `json:"link"` //
			CodeLink  string `json:"code_link"`
			AppId     string `json:"app_id"`
			AppSource string `json:"app_source"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: " + string(resp) + ", err:" + err.Error())
	}
	return &md.OfficialRecommendUrl{
		Url:               tmp.Data.Link,
		Appid:             tmp.Data.AppId,
		Id:                tmp.Data.AppSource,
		WxQrcodeUrl:       tmp.Data.CodeLink,
		WxMiniprogramPath: tmp.Data.Link,
	}, nil
}
