package zhimeng

import (
	"encoding/json"

	"applet/app/md"
	"applet/app/utils/logx"
)

// todo
func VipConvertUrl(ak, sk, itemId, pid, couponPrice, adCode, openId, realCall string) (*md.ConvertedUrls, error) {
	args := map[string]interface{}{
		"appkey":     ak,
		"secret_key": sk,
		"gid":        itemId,
		"pid":        pid,
		"adCode":     adCode,
		"openId":     openId,
		"realCall":   realCall,
	}
	resp, err := Send("wph_new", "url", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			URL      string `json:"url"`
			DeepUrl  string `json:"deep_url"`
			VipWxUrl string `json:"vipWxUrl"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: + " + string(resp) + " + err:" + err.Error())
	}
	return &md.ConvertedUrls{
		ItemId:          itemId,
		URL:             tmp.Data.URL,
		ShortenURL:      tmp.Data.URL,
		NoOpenAppURL:    tmp.Data.URL,
		AppURL:          tmp.Data.DeepUrl,
		HasCoupon:       false,
		CommissionRate:  couponPrice,
		WeChatMiniURL:   tmp.Data.VipWxUrl,
		WeChatMiniAPPID: md.APPLET_VIP_ID,
	}, nil
}
func VipActivityConvertUrl(ak, sk, url, pid, adCode, openId, realCall string) (*md.ConvertedUrls, error) {
	args := map[string]interface{}{
		"appkey":     ak,
		"secret_key": sk,
		"url":        "https://t.vip.com/d0Nxy38QC37",
		"pid":        pid,
		"adCode":     adCode,
		"openId":     openId,
		"realCall":   realCall,
	}
	resp, err := Send("wph_new", "act_url", args)
	if err != nil {
		return nil, logx.Warn(err)
	}
	var tmp struct {
		Data struct {
			URL      string `json:"url"`
			DeepUrl  string `json:"deep_url"`
			VipWxUrl string `json:"vipWxUrl"`
		} `json:"data"`
	}
	if err = json.Unmarshal(resp, &tmp); err != nil {
		return nil, logx.Warn("resp: + " + string(resp) + " + err:" + err.Error())
	}
	return &md.ConvertedUrls{
		URL:             tmp.Data.URL,
		ShortenURL:      tmp.Data.URL,
		NoOpenAppURL:    tmp.Data.URL,
		AppURL:          tmp.Data.DeepUrl,
		WeChatMiniURL:   tmp.Data.VipWxUrl,
		WeChatMiniAPPID: md.APPLET_VIP_ID,
	}, nil
}
