package md

type OilRequest struct {
	ItemName   string `json:"item_name"`    // 油号
	CityName   string `json:"city_name"`    // 城市
	Lat        string `json:"lat"`          // 纬度
	Lng        string `json:"lng"`          // 经度
	Sort       string `json:"sort"`         // 排序
	BrandName  string `json:"brand_name"`   // 品牌
	P          string `json:"p"`            // 页码
	Mobile     string `json:"mobile"`       // 手机号
	Id         string `json:"id"`           // id
	CategoryId string `json:"category_id"`  //id 多个是逗号隔开
	Pvd        string `json:"pvd"`          //类型
	IsReturnJh string `json:"is_return_jh"` //是否返回聚合链接
}

type OilList struct {
	Address    string   `json:"address"`
	BrandName  string   `json:"brand_name"`
	CityName   string   `json:"city_name"`
	CostPrice  string   `json:"cost_price"`
	Dis        string   `json:"dis"`
	ID         string   `json:"id"`
	InfoList   string   `json:"info_list"`
	ItemName   string   `json:"item_name"`
	Label      []string `json:"label"`
	Lat        string   `json:"lat"`
	Lng        string   `json:"lng"`
	Logo       string   `json:"logo"`
	Name       string   `json:"name"`
	OilID      string   `json:"oil_id"`
	StorePrice string   `json:"store_price"`
	UpdateTime string   `json:"update_time"`
	VipPrice   string   `json:"vip_price"`
	YhPrice    string   `json:"yh_price"`
}

type OilListResult struct {
	Address    string   `json:"address"`
	CityName   string   `json:"city_name"`
	CostPrice  string   `json:"cost_price"`
	Dis        string   `json:"dis"`
	ID         string   `json:"id"`
	Label      []string `json:"label"`
	Logo       string   `json:"logo"`
	Name       string   `json:"name"`
	StorePrice string   `json:"store_price"`
	Lat        string   `json:"lat"`
	Lng        string   `json:"lng"`
}

type OilDetail struct {
	Url string `json:"Url"`
}

type OilCarouselList struct {
	Img                string      `json:"img"`
	ImgURL             string      `json:"img_url"`
	Index              int         `json:"index"`
	IsJump             string      `json:"is_jump"`
	IsShow             string      `json:"is_show"`
	Name               string      `json:"name"`
	RequiredLogin      string      `json:"required_login"`
	RequiredTaobaoAuth string      `json:"required_taobao_auth"`
	SkipIdentifier     string      `json:"skip_identifier"`
	SkipName           string      `json:"skip_name"`
	Data               CommModData `json:"data"`
}

type OilStyle struct {
	BtnBgColor   string            `json:"btn_bg_color"`
	BtnStrColor  string            `json:"btn_str_color"`
	CarouselList []OilCarouselList `json:"carousel_list"`
	HeaderBg     struct {
		AssistColor string `json:"assist_color"`
		MainColor   string `json:"main_color"`
		MinColor    string `json:"min_color"`
	} `json:"header_bg"`
	NavImg        string `json:"nav_img"`
	NavImgUrl     string `json:"nav_img_url"`
	NavStrColor   string `json:"nav_str_color"`
	PriceStrColor string `json:"price_str_color"`
	Title         string `json:"title"`
	TitleColor    string `json:"title_color"`
	ItemNameList  []struct {
		Name string `json:"name"`
		Type string `json:"type"`
	} `json:"item_name_list"`
	BrandNameList []struct {
		Name string `json:"name"`
		Type string `json:"type"`
	} `json:"brand_name_list"`
	SortNameList []struct {
		Name string `json:"name"`
		Type string `json:"type"`
	} `json:"sort_name_list"`
}
