package md

const (
	UNPAID       = "0"
	PAID         = "1"
	REFUND       = "2"
	EXPIRE       = "3"
	CHECKSUCCESS = "4"
)

var ORD_STATE_LIST = map[string]string{
	UNPAID:       "未支付",
	PAID:         "付款成功",
	REFUND:       "已退款",
	EXPIRE:       "已失效",
	CHECKSUCCESS: "充值成功",
}

type PrivilegeCardGoods struct {
	ID            string `json:"id"`
	GID           string `json:"g_id"`
	Title         string `json:"title"`
	OfficialPrice string `json:"official_price"`
	PlatPrice     string `json:"plat_price"`
	Times         string `json:"times"`
	SpecID        string `json:"spec_id"`
	SpecImg       string `json:"spec_img"`
	UpdateTime    string `json:"update_time"`
	LID           string `json:"l_id"`
	Type          string `json:"type"`
	IsDelete      string `json:"is_delete"`
	TypeID        string `json:"type_id"`
	IsShowIdnum   string `json:"is_show_idnum"`
}

type PrivilegeCardBrand struct {
	ID          string `json:"id"`
	AccountType string `json:"account_type"`
	GID         string `json:"g_id"`
	GoodsLogo   string `json:"goods_logo"`
	GName       string `json:"g_name"`
	UpdateTime  string `json:"update_time"`
	Type        string `json:"type"`
	Xuzhi       string `json:"xuzhi"`
	IsDelete    string `json:"is_delete"`
	TypeID      string `json:"type_id"`
	IsShowArea  string `json:"is_show_area"`
}

//type b struct {
//	IsOpen        string `json:"is_open"`
//	CardName      string `json:"card_name"`
//	ConditionType string `json:"condition_type"`
//	ConditionData  `json:"condition_data"`
//	BalanceNoticeLimit string   `json:"balance_notice_limit"`
//	PaymentAvailable   []string `json:"payment_available"`
//	NewcomersGUIDURL   string   `json:"newcomers_guid_url"`
//}

type PrivilegeCardCfg struct {
	IsOpen            string      `json:"is_open"`
	CardName          string      `json:"card_name"`
	ConditionType     string      `json:"condition_type"`
	ConditionData     interface{} `json:"condition_data"`
	RegisterCondition struct {
		InviteCode struct {
			Popup       string `json:"popup"`
			ShouldInput string `json:"should_input"`
		} `json:"invite_code"`
		CardKey struct {
			Popup       string `json:"popup"`
			ShouldInput string `json:"should_input"`
		} `json:"card_key"`
	} `json:"register_condition"`
	BalanceNoticeLimit string   `json:"balance_notice_limit"`
	PaymentAvailable   []string `json:"payment_available"`
	NewcomersGUIDURL   string   `json:"newcomers_guid_url"`
}

// PrivilegeCardConditionCfg 2.条件开通
type PrivilegeCardConditionCfg []struct {
	Type  string `json:"type"`
	Level string `json:"level"`
}

// PrivilegeCardNeedMoneyCfg 3.付费开通
type PrivilegeCardNeedMoneyCfg struct {
	Type string `json:"type"` // 类型：1实体卡 2虚拟卡
	Cost []struct {
		DateType      string `json:"date_type"`
		CostPrice     string `json:"cost_price"`
		OriginalPrice string `json:"original_price"`
		IsOn          string `json:"is_on"`
	} `json:"cost"` // 价格设置
	GivenData []PrivilegeOpenCardGivenData `json:"given_data"` // 赠送设置
}

type PrivilegeOpenCardGivenData struct {
	Type string `json:"type"`
	Data struct {
		Level     string `json:"level"`
		Days      string `json:"days"`
		IsForever string `json:"is_forever"`
	} `json:"data"`
}
type PrivilegeOpenCardCoinCouponData struct {
	CouponAmount        string            `json:"coupon_amount"`
	CouponAmountTypeStr string            `json:"coupon_amount_type_str"`
	CouponAmountOnoff   string            `json:"coupon_amount_onoff"`
	VirtualCoinList     []VirtualCoinList `json:"virtual_coin_list"`
	VirtualCoinOnoff    string            `json:"virtual_coin_onoff"`
	Days                string            `json:"days"`
	IsForever           string            `json:"is_forever"`
	Level               string            `json:"level"`
	LvOnoff             string            `json:"lv_onoff"`
	IsGiven             int               `json:"is_given"`
}
type PrivilegeOpenCardLvData struct {
	Days      string `json:"days"`
	IsForever string `json:"is_forever"`
	Level     string `json:"level"`
	LvOnoff   string `json:"lv_onoff"`
}
type VirtualCoinList struct {
	ID    string `json:"id"`
	Name  string `json:"name"`
	Value string `json:"value"`
}

type PrivilegeCardGoodsNew struct {
	Id               int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	ZhimengId        int    `json:"zhimeng_id" xorm:"not null default 0 comment('智盟ID') INT(11)"`
	ThirdId          int    `json:"third_id" xorm:"not null default 0 comment('三方平台ID') INT(11)"`
	Name             string `json:"name" xorm:"not null default '' comment('商品名称') VARCHAR(255)"`
	OldName          string `json:"old_name" xorm:"not null default '' comment('商品名称') VARCHAR(255)"`
	GoodsImg         string `json:"goods_img" xorm:"not null default '' comment('商品图片') VARCHAR(255)"`
	BrandId          int    `json:"brand_id" xorm:"not null default 0 comment('品牌ID') INT(11)"`
	Times            string `json:"times" xorm:"not null default '' comment('时长') VARCHAR(255)"`
	CateId           int    `json:"cate_id" xorm:"not null default 0 comment('商品分类ID') INT(11)"`
	MarkupMode       int    `json:"markup_mode" xorm:"not null default 0 comment('加价模式 0为利润空间1为进货价') TINYINT(1)"`
	MarkupRate       int    `json:"markup_rate" xorm:"not null default 0 comment('加价比例') DECIMAL(5,2)"`
	OfficialPrice    string `json:"official_price" xorm:"not null default 0.00 comment('原价') DECIMAL(10,2)"`
	PlatformPrice    string `json:"platform_price" xorm:"not null default 0.00 comment('进货价') DECIMAL(10,2)"`
	FinalPrice       string `json:"final_price" xorm:"not null default 0.00 comment('销售价') DECIMAL(10,2)"`
	OldFinalPrice    string `json:"old_final_price" xorm:"not null default 0.00 comment('销售价') DECIMAL(10,2)"`
	Type             string `json:"type" xorm:"not null default '' comment('类型') VARCHAR(255)"`
	TypeId           string `json:"type_id" xorm:"not null default '' comment('类型id') VARCHAR(255)"`
	IsShow           int    `json:"is_show" xorm:"not null default 1 comment('是否显示') TINYINT(1)"`
	Sort             int    `json:"sort" xorm:"default 0 comment('排序') INT(11)"`
	CreatedAt        int    `json:"created_at" xorm:"not null default 0 INT(11)"`
	UpdatedAt        int    `json:"updated_at" xorm:"not null default 0 INT(11)"`
	DeletedAt        int    `json:"deleted_at" xorm:"not null default 0 INT(11)"`
	Data             string `json:"data" xorm:"not null comment('拓展用') LONGTEXT"`
	GoodsSales       int    `json:"goods_sales" xorm:"not null default 0 INT(11)"`
	IsCanBuy         string `json:"is_can_buy"`          //是否能购买
	IsShowCouponList string `json:"is_show_coupon_list"` //是否展示优惠券弹出
	UserCouponAmount string `json:"user_coupon_amount"`  //优惠券额度
	Coupon           string `json:"coupon"`              //
	IsShowIdnum      string `json:"is_show_idnum"`
	AreaType         string `json:"area_type"`
	CouponId         string `json:"coupon_id"`
	PriceStr         string `json:"price_str"`
}

type PrivilegeCheckPerm struct {
	State         bool               `json:"state"`
	Reason        string             `json:"reason"`
	ConditionType string             `json:"condition_type"`
	ConditionData interface{}        `json:"condition_data"`
	BtnStr        string             `json:"btn_str"`
	Skip          PrivilegeCheckSkip `json:"skip"`
}
type PrivilegeCheckSkip struct {
	Data               CommModData `json:"data"`
	IsJump             string      `json:"is_jump"`
	Name               string      `json:"name"`
	RequiredLogin      string      `json:"required_login"`
	RequiredTaobaoAuth string      `json:"required_taobao_auth"`
	SkipIdentifier     string      `json:"skip_identifier"`
	SkipName           string      `json:"skip_name"`
	URL                string      `json:"url"`
}

type PrivilegeAfterSuccessPopup struct {
	BgImg       string                         `json:"bg_img"`
	BtnImg      string                         `json:"btn_img"`
	Skip        SkipData                       `json:"skip"`
	SubTip      string                         `json:"sub_tip"`
	Tip         string                         `json:"tip"`
	TipType     string                         `json:"tip_type"`
	TextTipInfo PrivilegeAfterSuccessPopupText `json:"text_tip_info"`
}
type PrivilegeAfterSuccessPopupText struct {
	TopTitle      string `json:"title"`
	Content       string `json:"content"`
	SecondContent string `json:"second_content"`
	BtnStr        string `json:"btn_str"`
}
type PrivilegeCardArea struct {
	IsShowDistrict string                  `json:"is_show_district"`
	CountryArea    []PrivilegeCardAreaList `json:"country_area"`
	SouthArea      []PrivilegeCardAreaList `json:"south_area"`
}
type PrivilegeCardAreaList struct {
	Id       int64                       `json:"id"`
	Key      string                      `json:"key"`
	Value    string                      `json:"value"`
	CityList []PrivilegeCardAreaCityList `json:"city_list"`
}
type PrivilegeCardAreaCityList struct {
	Id int64 `json:"id"`

	Key          string                          `json:"key"`
	Value        string                          `json:"value"`
	DistrictList []PrivilegeCardAreaDistrictList `json:"district_list"`
}
type PrivilegeCardAreaDistrictList struct {
	Id int64 `json:"id"`

	Key   string `json:"key"`
	Value string `json:"value"`
}
