package svc

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/lib/push"
	"applet/app/md"
	"applet/app/utils"
	"fmt"
	"time"
	"xorm.io/xorm"
)

func OrderReturnMoneyRelateInsert(eg *xorm.Engine, oid int64, pvd string, createTime int, returnMoneyOne map[string]interface{}, newOrd *model.OrdList, masterId string, isDelete bool) {
	returnRelate, ok := returnMoneyOne["extend_commission"].([]interface{})
	if returnRelate == nil || ok == false {
		return
	}
	if isDelete {
		if newOrd.IsTotal == 1 {
			var ordRelate = make([]model.OrdListRelate, 0)
			eg.Where("oid=?", newOrd.OrdId).Find(&ordRelate)
			now := time.Unix(int64(newOrd.CreateAt), 0).Format("200601")
			nowDay := time.Unix(int64(newOrd.CreateAt), 0).Format("20060102")
			if len(ordRelate) > 0 {
				isDeduct := 0
				for _, v := range ordRelate {
					if v.Amount == 0 && utils.StrToFloat64(v.AdditionalSubsidy) == 0 {
						continue
					}
					var userStatistics model.UserMonthAmount
					eg.Where("uid=? and date=?", v.Uid, now).Get(&userStatistics)
					if userStatistics.Id != 0 {
						userStatistics.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
						eg.Where("id=?", userStatistics.Id).Cols("amount").Update(&userStatistics)
					}
					if v.CreateAt > 1711086661 {
						var userStatistics1 model.UserDayAmount
						eg.Where("uid=? and date=?", v.Uid, nowDay).Get(&userStatistics1)
						if userStatistics1.Id != 0 {
							userStatistics1 = model.UserDayAmount{
								Date: utils.StrToInt(nowDay),
								Uid:  v.Uid,
							}
							userStatistics1.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics1.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
							eg.Where("id=?", userStatistics1.Id).Cols("amount").Update(&userStatistics1)
						}
					}
					var userStatistics1 model.UserWaitAmount
					eg.Where("uid=? ", v.Uid).Get(&userStatistics1)
					if userStatistics1.Id != 0 {
						userStatistics1.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics1.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
						eg.Where("id=?", userStatistics1.Id).Cols("amount").Update(&userStatistics1)
					}
					isDeduct = 1
				}
				if isDeduct == 1 {
					if newOrd.State == 4 {
						newOrd.IsTotal = 2
					} else {
						newOrd.IsTotal = 0
					}
					eg.Where("pvd_oid=?", newOrd.PvdOid).Cols("is_total").Update(newOrd)
				}
			}
		}

		fmt.Println("=====================写入明细2", newOrd.PvdOid)
		if newOrd.ReturnMoneySettleAt > 0 {
			db.OrderRelateDeleteByOidbylevel(eg, oid, pvd)
		} else {
			db.OrderRelateDeleteByOid(eg, oid, pvd)
		}
	}
	var data []*model.OrdListRelate
	uid := 0
	for _, v := range returnRelate {
		v1 := v.(map[string]interface{})
		if int(utils.AnyToInt64(v1["diff"])) == 0 {
			uid = int(utils.AnyToInt64(v1["uid"]))
		}
		var tmp = &model.OrdListRelate{
			Oid:         oid,
			Uid:         int(utils.AnyToInt64(v1["uid"])),
			Amount:      utils.AnyToFloat64(v1["commission"]),
			ReturnMoney: utils.AnyToFloat64(v1["return_money"]),
			Pvd:         pvd,
			CreateAt:    createTime,
			Level:       int(utils.AnyToInt64(v1["diff"])),
		}
		if tmp.Level == 0 && newOrd.ReturnMoneySettleAt > 0 && isDelete {
			continue
		}
		data = append(data, tmp)
	}
	//后写入
	err := db.DbInsertBatch(eg, data)
	if err != nil {
		return
	}
	//后台推送
	appName := db.SysCfgGetWithDb(eg, masterId, "app_name_cn")
	if uid == 0 {
		return
	}
	users, err := db.UserFindByID(eg, uid)
	if users == nil || err != nil {
		return
	}
	if newOrd.IsSendMsg == 1 { //不发送
		return
	}
	for _, v := range data {
		if v.Amount == 0 {
			v.Amount = v.ReturnMoney
		}
		var args md.PushParams
		args.AppName = appName
		args.Nickname = users.Nickname
		args.RegNickname = users.Nickname
		args.RegPhone = users.Phone
		args.Payment = utils.Float64ToStr(newOrd.PaidPrice)
		args.OrderNickname = users.Nickname
		args.OrderNo = newOrd.PvdOid
		args.OrderTime = time.Unix(int64(newOrd.CreateAt), 0).Format("2006-1-02 15:04:05")
		args.Fcommission = utils.Float64ToStr(v.Amount)
		args.Money = utils.Float64ToStr(v.Amount)
		args.Uid = v.Uid
		args.MasterId = masterId
		args.PushType = "order_team"
		if v.Level == 0 && newOrd.OrderType == 0 {
			args.PushType = "order_self"
		}
		if v.Level == 0 && newOrd.OrderType == 1 {
			args.PushType = "order_share"
		}
		if v.Level == 0 || v.Amount > 0 {
			args.Times = time.Now().Format("2006-01-02")
			push.CommAddPush(eg, args)
		}
	}
	newOrd.IsSendMsg = 1
	_, _ = db.OrdUpdateOne(eg, newOrd)

}
func PlayLetOrderReturnMoneyRelateInsert(eg *xorm.Engine, oid int64, pvd string, createTime int, returnMoneyOne map[string]interface{}, newOrd *model.OrdList, masterId string, isDelete bool) {
	returnRelate, ok := returnMoneyOne["extend_commission"].([]interface{})
	if returnRelate == nil || ok == false {
		return
	}
	if isDelete {
		if newOrd.IsTotal == 1 {
			var ordRelate = make([]model.OrdListRelate, 0)
			eg.Where("oid=?", newOrd.OrdId).Find(&ordRelate)
			now := time.Unix(int64(newOrd.CreateAt), 0).Format("200601")
			nowDay := time.Unix(int64(newOrd.CreateAt), 0).Format("20060102")
			if len(ordRelate) > 0 {
				isDeduct := 0
				for _, v := range ordRelate {
					if v.Amount == 0 && utils.StrToFloat64(v.AdditionalSubsidy) == 0 {
						continue
					}
					var userStatistics model.UserMonthAmount
					eg.Where("uid=? and date=?", v.Uid, now).Get(&userStatistics)
					if userStatistics.Id != 0 {
						userStatistics.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
						eg.Where("id=?", userStatistics.Id).Cols("amount").Update(&userStatistics)
					}
					if v.CreateAt > 1711086661 {
						var userStatistics1 model.UserDayAmount
						eg.Where("uid=? and date=?", v.Uid, nowDay).Get(&userStatistics1)
						if userStatistics1.Id != 0 {
							userStatistics1 = model.UserDayAmount{
								Date: utils.StrToInt(nowDay),
								Uid:  v.Uid,
							}
							userStatistics1.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics1.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
							eg.Where("id=?", userStatistics1.Id).Cols("amount").Update(&userStatistics1)
						}
					}
					var userStatistics1 model.UserWaitAmount
					eg.Where("uid=? ", v.Uid).Get(&userStatistics1)
					if userStatistics1.Id != 0 {
						userStatistics1.Amount = utils.Float64ToStrByPrec(utils.StrToFloat64(userStatistics1.Amount)-v.Amount-utils.StrToFloat64(v.AdditionalSubsidy), 4)
						eg.Where("id=?", userStatistics1.Id).Cols("amount").Update(&userStatistics1)
					}
					isDeduct = 1
				}
				if isDeduct == 1 {
					if newOrd.State == 4 {
						newOrd.IsTotal = 2
					} else {
						newOrd.IsTotal = 0
					}
					eg.Where("pvd_oid=?", newOrd.PvdOid).Cols("is_total").Update(newOrd)
				}
			}
		}

		fmt.Println("=====================写入明细2", newOrd.PvdOid)
		if newOrd.ReturnMoneySettleAt > 0 {
			db.OrderRelateDeleteByOidbylevel(eg, oid, pvd)
		} else {
			db.OrderRelateDeleteByOid(eg, oid, pvd)
		}
	}
	var data []*model.OrdListRelate
	for _, v := range returnRelate {
		v1 := v.(map[string]interface{})
		var tmp = &model.OrdListRelate{
			Oid:         oid,
			Uid:         int(utils.AnyToInt64(v1["uid"])),
			Amount:      utils.AnyToFloat64(v1["commission"]),
			ReturnMoney: utils.AnyToFloat64(v1["return_money"]),
			Pvd:         pvd,
			CreateAt:    createTime,
			Level:       int(utils.AnyToInt64(v1["diff"])),
		}
		if tmp.Level == 0 && newOrd.ReturnMoneySettleAt > 0 && isDelete {
			continue
		}
		data = append(data, tmp)
	}
	//后写入
	err := db.DbInsertBatch(eg, data)
	if err != nil {
		return
	}

}
