package svc

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/md"
	"applet/app/utils"
	"time"
	"xorm.io/xorm"
)

func AddPlacardRecord(Db *xorm.Engine, uid int, name, str, types, coupon, typeId string) {
	if uid == 0 {
		return
	}
	if Db == nil {
		return
	}
	//加入公告优惠记录
	user, _ := db.UserFindByID(Db, uid)
	nickname := ""
	if user != nil {
		nickname = user.Nickname
	}
	hideNickname := utils.HideTrueName(nickname)
	if types == md.PVD_CARD {
		str = "购买" + name
		if typeId == "recharge" {
			str = "充值" + name
		}
		str = "用户" + hideNickname + ",[时间]" + str + "节省了" + coupon + "元"
	}
	if types == md.PVD_OILSTATION {
		str = "用户" + hideNickname + ",[时间]加油节省了" + coupon + "元"
	}
	var args = map[string]string{
		"uid":     utils.IntToStr(uid),
		"phone":   nickname,
		"content": str,
		"price":   coupon,
		"type":    types,
	}
	InsertPlacardRecord(Db, args)
}
func InsertPlacardRecord(eg *xorm.Engine, args map[string]string) {

	var arg = &model.PlacardRecord{
		Uid:     utils.StrToInt(args["uid"]),
		Phone:   args["phone"],
		Content: args["content"],
		Time:    int(time.Now().Unix()),
		IsXuni:  0,
		Price:   args["price"],
		Type:    args["type"],
		Data:    args["data"],
	}
	db.PlacardRecordCreate(eg, arg)
}
