package svc

import (
	"applet/app/db"
	"applet/app/db/model"
	"applet/app/lib/plan"
	"applet/app/lib/taobao"
	"applet/app/md"
	"applet/app/utils"
	"applet/app/utils/cache"
	"applet/app/utils/logx"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/lib/comm_plan"
	"fmt"
	"github.com/tidwall/gjson"
	"strings"
	"time"
	"xorm.io/xorm"
)

var taobaoRefundArgs = []map[string]string{
	{"biz_type": "1"},
	{"biz_type": "2"},
}

func DeductMoney(eg *xorm.Engine, existOrd model.OrdList, ords map[string]md.OrderInfo, pvd string, pidToUser map[string]*md.UserPid, opts map[string]*plan.PlanOpt, dbName, str string) {
	if existOrd.Uid == 0 {
		return
	}
	pid := ords[existOrd.PvdOid].Pid
	var user *md.UserPid
	var oid = existOrd.OrdId
	user = pidToUser[pid]
	newPvds := pvd
	//判断是饿了么的
	if ords[existOrd.PvdOid].Pvd == "ele" {
		newPvds = "ele"
	}
	newOpts := opts[newPvds]
	var lvUser *comm_plan.LvUser
	var pvdFee float64
	var sysFee float64
	var subsidyFee float64
	var subsidyRate float64
	var profit float64 = 0
	var selfRate float64 = 0
	var err error
	//计算佣金
	isShare := 0
	if ords[existOrd.PvdOid].OrderType == md.OrderTypeShare || ords[existOrd.PvdOid].OrderType == md.OrderTypeWechatActShare {
		isShare = 1
	}
	//调用公共的分佣
	req := md.CommissionFirstParam{
		CommissionParam: md.CommissionParam{
			Commission: utils.Float64ToStr(ords[existOrd.PvdOid].Commission),
			PaidPrice:  utils.Float64ToStr(ords[existOrd.PvdOid].PaidPrice),
			OldPrice:   utils.Float64ToStr(ords[existOrd.PvdOid].PaidPrice),
		},
		Uid:              utils.IntToStr(user.Uid),
		IsShare:          isShare,
		Provider:         newPvds,
		IsAllLevelReturn: 1,
		GoodsId:          utils.Int64ToStr(ords[existOrd.PvdOid].Oid),
	}
	commissionList, err := GetCommissionByCommApi(eg, dbName, req)
	if err != nil || commissionList.LvUser == nil {
		return
	}
	pvdFee = commissionList.PvdFee
	sysFee = commissionList.SysFee
	subsidyFee = commissionList.SubsidyFee
	lvUser = commissionList.LvUser
	profit = commissionList.Profit
	mode := ""
	if newOpts.Mode != "" {
		mode = newOpts.Mode
	}
	data := OrderRelateInsertComm(eg, oid, newPvds, existOrd.CreateAt, lvUser, &existOrd, dbName, mode)
	if data == nil {
		return
	}
	var newRebateList = make(map[int]float64, 0)
	for _, v := range data {
		newRebateList[v.Uid] = v.Amount
	}

	fmt.Println(lvUser)
	if lvUser == nil {
		return
	}
	//判断下这个等级有么有设置
	if newOpts.UserRate != nil {
		for k, item := range newOpts.UserRate {
			if k == 0 {
				selfRate = item.SelfRate
				subsidyRate = item.SubsidyShareRate
				if ords[existOrd.PvdOid].OrderType == 0 {
					subsidyRate = item.SubsidySelfRate
				}
			}
			if k == user.Lv {
				selfRate = item.SelfRate
				selfRate = item.SelfRate
				subsidyRate = item.SubsidyShareRate
				if ords[existOrd.PvdOid].OrderType == 0 {
					subsidyRate = item.SubsidySelfRate
				}
			}
		}
	}
	existOrd.SubsidyFee = subsidyFee
	existOrd.SubsidyRate = subsidyRate
	existOrd.UserCommission = profit
	existOrd.UserCommissionRate = selfRate
	existOrd.PvdCommission = pvdFee
	existOrd.PvdCommissionRate = newOpts.PvdRate
	existOrd.SysCommission = sysFee
	existOrd.SysCommissionRate = newOpts.SysRate
	existOrd.PlanCommissionId = newOpts.PlanCommissionId
	if existOrd.BenefitAll <= 0 {
		existOrd.BenefitAll = ords[existOrd.PvdOid].Commission
	}
	existOrd.BenefitList = SerializeLvUser(CalcLvUserFee(lvUser))
	//读取之前的订单
	rebateList, err := db.OrderRelateListByOid(eg, oid, existOrd.Pvd)
	if rebateList == nil || err != nil {
		return
	}
	//计算要扣的金额
	for k, v := range rebateList {
		rebateList[k].Amount = v.Amount - newRebateList[v.Uid]
		if rebateList[k].Amount < 0 {
			rebateList[k].Amount = 0
		}
	}
	//扣除
	session := eg.NewSession()
	defer session.Close()
	if err := session.Begin(); err != nil {
		_ = logx.Warn(err)
		return
	}
	if existOrd.SettleAt > 0 {
		commRefund(eg, session, &existOrd, existOrd.Uid, existOrd.Pvd, existOrd.ItemId, rebateList, str, dbName)
		commAreaRefund(session, existOrd.Uid, utils.Int64ToStr(existOrd.OrdId), md.PVD_GUIDE, existOrd.ItemId, str)
		commStoreRefund(eg, session, utils.Int64ToStr(existOrd.OrdId), existOrd.Pvd)
		existOrd.IsRefund = 1
	}
	_, _ = db.OrdUpdateOneAll(eg, &existOrd)
	//重新分佣
	_, _ = db.OrderRelateDeleteByOid(eg, existOrd.OrdId, existOrd.Pvd)
	err = db.DbInsertBatch(eg, data)
	if err != nil {
		session.Rollback()
		return
	}
	// 提交事务
	err = session.Commit()
	if err != nil {
		_ = logx.Warn(err)
		return
	}
	return
}
func deductMoneySecond(eg *xorm.Engine, existOrd model.OrdList, dbName, str string) {
	if existOrd.Uid == 0 {
		return
	}
	var oid = existOrd.OrdId
	//读取之前的订单
	rebateList, err := db.OrderRelateListByOid(eg, oid, existOrd.Pvd)
	if rebateList == nil || err != nil {
		return
	}
	//计算要扣的金额
	for k, v := range rebateList {
		rebateList[k].Amount = v.Amount
		if rebateList[k].Amount < 0 {
			rebateList[k].Amount = 0
		}
	}
	//扣除
	session := eg.NewSession()
	defer session.Close()
	if err := session.Begin(); err != nil {
		_ = logx.Warn(err)
		return
	}
	if existOrd.SettleAt > 0 {
		commRefund(eg, session, &existOrd, existOrd.Uid, existOrd.Pvd, existOrd.ItemId, rebateList, str, dbName)
		commAreaRefund(session, existOrd.Uid, utils.Int64ToStr(existOrd.OrdId), md.PVD_GUIDE, existOrd.ItemId, str)
		commStoreRefund(eg, session, utils.Int64ToStr(existOrd.OrdId), existOrd.Pvd)
		existOrd.IsRefund = 1
	}
	_, _ = db.OrdUpdateOneAll(eg, &existOrd)
	// 提交事务
	err = session.Commit()
	if err != nil {
		_ = logx.Warn(err)
		return
	}
	return
}
func TbOrderRefundTrack(eg *xorm.Engine, dbName, unionId string) {
	tbArgs := taobaoRefundArgs
	var taobaoCfg *model.SysUnionSet
	if unionId != "" {
		taobaoCfg = db.SysUnionById(eg, unionId)
	} else {
		taobaoCfg, _ = db.SysUnionByTaobaoByUseByAuth(eg, dbName)
	}
	if taobaoCfg == nil {
		return
	}
	Svc_AK := "26302019"
	Svc_SK := "ba877cfcdc64d3fbc1105d61d66dd1d7"
	if taobaoCfg.AuthTime.Unix() >= utils.TimeStdParseUnix(taobao.TB_SVC_TIME) {
		Svc_AK = taobao.TB_SVC_AK
		Svc_SK = taobao.TB_SVC_SK
	}
	var cs = &taobao.TB{
		SID:    gjson.Get(taobaoCfg.KeyData, "accessToken").String(),
		Svc_AK: Svc_AK,
		Svc_SK: Svc_SK,
	}
	//cs.SID = "62000083591c0ddacef53826ab25fa1514b8abe1372db93166389044"
	args := map[string]string{}
	args = tbArgs[0]
	// 获得最后时间
	pvdTimeKey := md.KEY_CFG_CRON_TIME_TBREFUND
	if unionId != "" {
		pvdTimeKey += "_" + unionId
	}
	latest, err := db.DbsSysCfgGet(eg, pvdTimeKey)
	if err != nil || latest == nil {
		db.DbsSysCfgInserts(eg, pvdTimeKey, time.Now().String())
		latest, _ = db.DbsSysCfgGet(eg, pvdTimeKey)
	}
	now := time.Now().Unix()
	strs := strings.Split(latest.Val, ":")
	timeStr := latest.Val
	if len(strs) == 3 {
		timeStr = strs[0] + ":" + strs[1] + ":00"
	}
	littlePocket := db.SysCfgFindWithDb(eg, dbName, "little_pocket_basic_data")
	returnMoneyType := "0"
	if littlePocket != nil && gjson.Get(littlePocket["little_pocket_basic_data"], "return_money_type").String() == "1" {
		returnMoneyType = "1"
	}
	past := utils.TimeParseStd(timeStr).Unix()
	if past > now {
		past = now
	}
	var (
		beginTime int64 = 0
		pageNo    int   = 1
		pageSize  int   = 50
	)
	for {
		//  分配堆内存
		time.Sleep(time.Microsecond * 500) // 等待500毫秒
		if eg == nil {
			return
		}

		var allOrdIds []string
		var pidToUser = map[string]*md.UserPid{}
		ords := map[string]taobao.RefundOrder{}
		newOrds := map[string]md.OrderInfo{}
		var existOrds *[]model.OrdList
		beginTime = past - 3600
		order, _ := taobao.New(cs).RefundOrder(pageNo, pageSize, beginTime, 0, args)
		if err != nil || order == nil || len(*order) == 0 {
			goto ChkArg
		}
		//处理订单是否可以退款
		for _, v := range *order {
			// 如果订单存在则更改订单状态, 其它不需要操作, 结算由另外一个任务进行结算
			tid := utils.Int64ToStr(v.TbTradeID)
			allOrdIds = append(allOrdIds, tid)
			ords[tid] = v
		}
		existOrds, _ = db.DbsOrderFindByIds(eg, md.PVD_TB, allOrdIds)
		fmt.Println("========================================")
		fmt.Println(existOrds)
		if existOrds != nil {
			//存在的订单判断有没有返佣过
			for _, v := range *existOrds {

				if ords[v.PvdOid].RefundStatus != 2 { //没有维权成功
					continue
				}
				// 加锁 防止并发退款
				mutexKey := fmt.Sprintf("%s:all_order_refund:%d:pvd:%s", dbName, v.OrdId, v.Pvd)
				available, err := cache.Do("SET", mutexKey, 1, "EX", 5, "NX")
				if err != nil {
					continue
				}
				if available != "OK" {
					continue
				}
				if v.IsRefund > 0 {
					continue
				}
				//如果付款金额大于退款金额 只是部分退款 要扣掉佣金 重新分佣
				if utils.FloatFormat(v.PaidPrice, 3) > utils.StrToFloat64(ords[v.PvdOid].RefundFee) && v.IsRefund == 0 {
					if returnMoneyType == "1" {
						continue
					}
					//处理返佣方案
					opts := PlanOpts(eg)
					if opts == nil || opts[v.Pvd] == nil {
						return
					}
					pid := "self_" + utils.IntToStr(v.Uid)
					if v.OrderType == 1 {
						pid = "share_" + utils.IntToStr(v.Uid)
					}
					if v.OrderType == 2 {
						pid = "free_" + utils.IntToStr(v.Uid)
					}
					//计算剩余可返的佣金  佣金=应返商家金额/维权金额*结算金额
					var commission = utils.StrToFloat64(ords[v.PvdOid].TkPubShowReturnFee) / utils.StrToFloat64(ords[v.PvdOid].RefundFee) * utils.StrToFloat64(ords[v.PvdOid].TbTradeFinishPrice)
					var bili = commission / v.PaidPrice
					v.BenefitAll = utils.FloatFormat(bili*(utils.StrToFloat64(ords[v.PvdOid].TbTradeFinishPrice)-utils.StrToFloat64(ords[v.PvdOid].RefundFee)), 2)
					v.BenefitAll = utils.FloatFormat(v.BenefitAll, 2)
					pidToUser[pid] = &md.UserPid{Uid: v.Uid, OrderType: v.OrderType}
					newOrds[v.PvdOid] = md.OrderInfo{ItemPrice: v.ItemPrice, PaidPrice: v.PaidPrice, Pid: pid, Pvd: v.Pvd, OrderType: v.OrderType, PvdOid: v.PvdOid, Commission: v.BenefitAll}
					if v.SettleAt == 0 && v.IsFastSign == 1 && v.IsWaitReduce == 0 {
						FastReturnReduceOrderSecond(eg, v.Uid, utils.Int64ToStr(v.OrdId), dbName)
					}
					DeductMoney(eg, v, newOrds, v.Pvd, pidToUser, opts, dbName, "")
					v.IsRefund = 1
					v.PlatformData = "{\"punish_status\":\"0\",\"violation_type\":\"\",\"state\":\"部分退款\"}"
					_, _ = db.OrdUpdateOne(eg, &v)
					if v.Uid == 0 {
						v.State = 4
						v.IsRefund = 1
						v.SettleAt = 0
						_, _ = db.OrdUpdateOne(eg, &v)
					}
				} else { //修改成失败
					if v.SettleAt > 0 || v.State == 5 {
						RefundDoing(eg, returnMoneyType, &v, "", dbName) //先扣除分佣
					}
					v.PlatformData = "{\"punish_status\":\"0\",\"violation_type\":\"\",\"state\":\"订单退款\"}"
					v.State = 4
					v.IsRefund = 1
					v.SettleAt = 0
					_, _ = db.OrdUpdateOne(eg, &v)
				}
			}
		}
		// 判断是否分页已经全部取完了
		if len(*order) == pageSize {
			pageNo++
			fmt.Println("========下一页========" + utils.IntToStr(pageNo))
			order = nil
			continue
		}
	ChkArg:
		// 判断其它参数, 淘宝需要请求9次, 考拉3次
		if len(tbArgs) > 0 {
			args = tbArgs[0]
			if len(tbArgs) == 1 {
				tbArgs = nil
			} else {
				tbArgs = tbArgs[1:]
			}
			order = nil
			continue
		}
		//// 查询完后重置时间, 最后查询时间
		if past < now {
			pageNo = 1
			db.DbsSysCfgUpdate(eg, pvdTimeKey, utils.TimeToStr(past+3500))
			beginTime = past + 3500
			past = beginTime
			if beginTime > now {
				beginTime = now
			}
			args = taobaoRefundArgs[0]
			tbArgs = taobaoRefundArgs[1:]
			continue
		}

		order = nil
		break
	}
	db.DbsSysCfgUpdate(eg, pvdTimeKey, utils.TimeToStr(past+3500))
	// 更新最后供应商执行订单时间
	return
}
